#! /bin/sh -
### ====================================================================
### Given one or more DOIs on the command line (with or without the
### "http://dx.doi.org/" prefix), generate rough BibTeX entries by
### online database lookup.
###
### This tool can be useful for recovering additional data, such as
### missing number and month values, for existing BibTeX entries.
###
### Usage:
###	doi-to-bibtex.sh doi-1 doi-2 ... > foo.bib
###	doi-to-bibtex.sh doi-1 doi-2 ... | bibclean > foo.bib
###	doi-to-bibtex.sh doi-1 doi-2 ... | fix-order.sh > foo.bib
###	doi-to-bibtex.sh doi-1 doi-2 ... | fix-order.sh | journal.sh > foo.bib
###
### [25-Nov-2015]
### ====================================================================

IFS='
 	'

PATH=/bin:/usr/bin

case "`uname -s`" in
    DragonFly)		PATH=/usr/local/bin:$PATH ;;
    FreeBSD)		PATH=/usr/local/bin:$PATH ;;
    LibertyBSD)		PATH=/usr/local/bin:$PATH ;;
    MidnightBSD)	PATH=/usr/local/bin:$PATH ;;
    NetBSD)		PATH=/usr/pkg/bin:$PATH   ;;
    OpenBSD)		PATH=/usr/local/bin:$PATH ;;
    *)			;;
esac

export PATH

for f in "$@"
do
    printf "\n%%%% DOI: %s\n\n" "$f"
    g=`echo $f | sed -e s@https*://dx.doi.org/@@ -e 's@https*://doi.org/@@' -e 's@https://www.pnas.org/cgi/doi/@@' `
    curl --insecure -LH "Accept: application/x-bibtex" --silent https://doi.org/"$g" | sed -e 's@%2F@/@g'
    printf "\n\n"
done
